//
//  MainController.h
//  RollOverButtonTest
//
//  Created by Andreas on Fri Jan 30 2004.
//  Copyright (c) 2004 Andreas Mayer. All rights reserved.
//
//	2011-08-08	- renamed some outlets
//					- added -importDesign: and -exportDesign: methods; renamed -revertColors: to -revertDesign:


#import <Foundation/Foundation.h>
#import "AMRollOverButton.h"


@interface MainController : NSObject <NSApplicationDelegate> {
	IBOutlet NSWindow *theWindow;
	IBOutlet AMRollOverButton *theButton;
	IBOutlet NSMenu *theMenu;
	IBOutlet NSTextField *clickCount;
	IBOutlet NSColorWell *controlColor;
	IBOutlet NSColorWell *shadingColor;
	IBOutlet NSColorWell *frameColor;
	IBOutlet NSColorWell *textColor;
	IBOutlet NSColorWell *arrowColor;
	IBOutlet NSColorWell *textShadowColor;
	IBOutlet NSColorWell *controlShadowColor;
	IBOutlet NSColorWell *mouseoverControlColor;
	IBOutlet NSColorWell *mouseoverShadingColor;
	IBOutlet NSColorWell *mouseoverFrameColor;
	IBOutlet NSColorWell *mouseoverTextColor;
	IBOutlet NSColorWell *mouseoverArrowColor;
	IBOutlet NSColorWell *mouseoverTextShadowColor;
	IBOutlet NSColorWell *highlightedControlColor;
	IBOutlet NSColorWell *highlightedShadingColor;
	IBOutlet NSColorWell *highlightedFrameColor;
	IBOutlet NSColorWell *highlightedTextColor;
	IBOutlet NSColorWell *highlightedArrowColor;
	IBOutlet NSColorWell *highlightedTextShadowColor;
	IBOutlet NSTextField *title;
	IBOutlet NSPopUpButton *sizePopUp;
	IBOutlet NSPopUpButton *typePopUp;
	IBOutlet NSPopUpButton *stylePopUp;
	IBOutlet NSPopUpButton *shadingPopUp;
	IBOutlet NSButton *displayBorder;
	IBOutlet NSButton *hasMenu;
	IBOutlet NSButton *displayArrow;
	IBOutlet NSTextField *menuDelayText;
	IBOutlet NSSlider *menuDelaySlider;
	IBOutlet NSWindow *matrixTestWindow;
	IBOutlet NSLayoutConstraint *stupidVerticalSpacingConstraint;
	IBOutlet NSView *viewThatHoldsStupidVerticalSpacingConstraint;
	AMRollOverButtonAppearance *defaultAppearance;
	NSSound *clickSound;
}

@property (retain) AMRollOverButtonAppearance *defaultAppearance;
@property (retain) NSSound *clickSound;

// ======================================================
#pragma mark - Action Methods
// ======================================================

- (IBAction)ImportDesign:(id)sender;

- (IBAction)ExportDesign:(id)sender;

- (IBAction)changeColor:(id)sender;

- (IBAction)changeTitle:(id)sender;

- (IBAction)changeStyle:(id)sender;

- (IBAction)changeSize:(id)sender;

- (IBAction)changeDisplayBorder:(id)sender;

- (IBAction)changeDisplayMenu:(id)sender;

- (IBAction)changeDisplayArrow:(id)sender;

- (IBAction)revertDesign:(id)sender;

- (IBAction)changeMenuDelay:(id)sender;

- (IBAction)changeShadingMode:(id)sender;

- (IBAction)changeButtonType:(id)sender;

- (IBAction)click:(id)sender;

@end
