//
//  AMRollOverButtonAppearance.m
//  RollOverButtonTest
//
//  Created by Andreas Mayer on 28.07.11.
//  Copyright 2011 Andreas Mayer. All rights reserved.
//

#import "AMRollOverButtonAppearance.h"

@implementation AMRollOverButtonAppearance

@synthesize controlColor = am_controlColor;
@synthesize frameColor = am_frameColor;
@synthesize textColor = am_textColor;
@synthesize arrowColor = am_arrowColor;
@synthesize shadingColor = am_shadingColor;
@synthesize mouseoverControlColor = am_mouseoverControlColor;
@synthesize mouseoverFrameColor = am_mouseoverFrameColor;
@synthesize mouseoverTextColor = am_mouseoverTextColor;
@synthesize mouseoverArrowColor = am_mouseoverArrowColor;
@synthesize mouseoverShadingColor = am_mouseoverShadingColor;
@synthesize highlightedControlColor = am_highlightedControlColor;
@synthesize highlightedFrameColor = am_highlightedFrameColor;
@synthesize highlightedTextColor = am_highlightedTextColor;
@synthesize highlightedArrowColor = am_highlightedArrowColor;
@synthesize highlightedShadingColor = am_highlightedShadingColor;
@synthesize controlShadow = am_controlShadow;
@synthesize textShadow = am_textShadow;
@synthesize mouseoverTextShadow = am_mouseoverTextShadow;
@synthesize highlightedTextShadow = am_highlightedTextShadow;
@synthesize highlightedControlShadow = am_highlightedControlShadow;
@synthesize bezelStyle = am_bezelStyle;
@synthesize shadingMode = am_shadingMode;
@synthesize bordered = am_bordered;
@synthesize popUpMenuDelay = am_popUpMenuDelay;
@synthesize alwaysShowMenuIndicator = am_alwaysShowMenuIndicator;

// ======================================================
#pragma mark - Class methods
// ======================================================

+ (NSData *)dataRepresentationFromAppearance:(AMRollOverButtonAppearance *)appearance
{
	return [NSKeyedArchiver archivedDataWithRootObject:appearance];
}

+ (AMRollOverButtonAppearance *)appearanceWithDataRepresentation:(NSData *)data
{
	AMRollOverButtonAppearance *result = [NSKeyedUnarchiver unarchiveObjectWithData:data];
	return result;
}

// ======================================================
#pragma mark - Initialization
// ======================================================

- (void)dealloc {
	[am_controlColor release];
	[am_frameColor release];
	[am_textColor release];
	[am_arrowColor release];
	[am_shadingColor release];
	[am_mouseoverControlColor release];
	[am_mouseoverFrameColor release];
	[am_mouseoverTextColor release];
	[am_mouseoverArrowColor release];
	[am_mouseoverShadingColor release];
	[am_highlightedControlColor release];
	[am_highlightedFrameColor release];
	[am_highlightedTextColor release];
	[am_highlightedArrowColor release];
	[am_highlightedShadingColor release];
	[am_controlShadow release];
	[am_textShadow release];
	[am_mouseoverTextShadow release];
	[am_highlightedTextShadow release];
	[am_highlightedControlShadow release];
	[super dealloc];
}

- (id)copyWithZone:(NSZone*)aZone
{
	AMRollOverButtonAppearance *result = [[AMRollOverButtonAppearance alloc] init];
	NSColor *copiedColor = nil;
	copiedColor = [[self controlColor] copyWithZone:aZone];
	result.controlColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self frameColor] copyWithZone:aZone];
	result.frameColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self textColor] copyWithZone:aZone];
	result.textColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self arrowColor] copyWithZone:aZone];
	result.arrowColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self shadingColor] copyWithZone:aZone];
	result.shadingColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self mouseoverControlColor] copyWithZone:aZone];
	result.mouseoverControlColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self mouseoverFrameColor] copyWithZone:aZone];
	result.mouseoverFrameColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self mouseoverTextColor] copyWithZone:aZone];
	result.mouseoverTextColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self mouseoverArrowColor] copyWithZone:aZone];
	result.mouseoverArrowColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self mouseoverShadingColor] copyWithZone:aZone];
	result.mouseoverShadingColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self highlightedControlColor] copyWithZone:aZone];
	result.highlightedControlColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self highlightedFrameColor] copyWithZone:aZone];
	result.highlightedFrameColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self highlightedTextColor] copyWithZone:aZone];
	result.highlightedTextColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self highlightedArrowColor] copyWithZone:aZone];
	result.highlightedArrowColor = copiedColor;
	[copiedColor release];
	copiedColor = [[self highlightedShadingColor] copyWithZone:aZone];
	result.highlightedShadingColor = copiedColor;
	[copiedColor release];
	NSShadow *copiedShadow = nil;
	copiedShadow = [[self controlShadow] copyWithZone:aZone];
	result.controlShadow = copiedShadow;
	[copiedShadow release];
	copiedShadow = [[self textShadow] copyWithZone:aZone];
	result.textShadow = copiedShadow;
	[copiedShadow release];
	copiedShadow = [[self mouseoverTextShadow] copyWithZone:aZone];
	result.mouseoverTextShadow = copiedShadow;
	[copiedShadow release];
	copiedShadow = [[self highlightedTextShadow] copyWithZone:aZone];
	result.highlightedTextShadow = copiedShadow;
	[copiedShadow release];
	copiedShadow = [[self highlightedControlShadow] copyWithZone:aZone];
	result.highlightedControlShadow = copiedShadow;
	[copiedShadow release];
	result.bezelStyle = self.bezelStyle;
	result.shadingMode = self.shadingMode;
	result.bordered = self.bordered;
	result.popUpMenuDelay = self.popUpMenuDelay;
	result.alwaysShowMenuIndicator = self.alwaysShowMenuIndicator;
	return result;
}


- (void)encodeWithCoder:(NSCoder *)coder {
	[coder encodeObject:self.controlColor forKey:@"am_controlColor"];
	[coder encodeObject:self.frameColor forKey:@"am_frameColor"];
	[coder encodeObject:self.textColor forKey:@"am_textColor"];
	[coder encodeObject:self.arrowColor forKey:@"am_arrowColor"];
	[coder encodeObject:self.shadingColor forKey:@"am_shadingColor"];
	[coder encodeObject:self.mouseoverControlColor forKey:@"am_mouseoverControlColor"];
	[coder encodeObject:self.mouseoverFrameColor forKey:@"am_mouseoverFrameColor"];
	[coder encodeObject:self.mouseoverTextColor forKey:@"am_mouseoverTextColor"];
	[coder encodeObject:self.mouseoverArrowColor forKey:@"am_mouseoverArrowColor"];
	[coder encodeObject:self.mouseoverShadingColor forKey:@"am_mouseoverShadingColor"];
	[coder encodeObject:self.highlightedControlColor forKey:@"am_highlightedControlColor"];
	[coder encodeObject:self.highlightedFrameColor forKey:@"am_highlightedFrameColor"];
	[coder encodeObject:self.highlightedTextColor forKey:@"am_highlightedTextColor"];
	[coder encodeObject:self.highlightedArrowColor forKey:@"am_highlightedArrowColor"];
	[coder encodeObject:self.highlightedShadingColor forKey:@"am_highlightedShadingColor"];
	[coder encodeObject:self.controlShadow forKey:@"am_controlShadow"];
	[coder encodeObject:self.textShadow forKey:@"am_textShadow"];
	[coder encodeObject:self.mouseoverTextShadow forKey:@"am_mouseoverTextShadow"];
	[coder encodeObject:self.highlightedTextShadow forKey:@"am_highlightedTextShadow"];
	[coder encodeObject:self.highlightedControlShadow forKey:@"am_highlightedControlShadow"];
	[coder encodeInteger:self.bezelStyle forKey:@"am_bezelStyle"];
	[coder encodeInteger:self.shadingMode forKey:@"am_shadingMode"];
	[coder encodeBool:self.bordered forKey:@"am_bordered"];
	[coder encodeDouble:self.popUpMenuDelay forKey:@"am_popUpMenuDelay"];
	[coder encodeBool:self.alwaysShowMenuIndicator forKey:@"am_alwaysShowMenuIndicator"];
}

- (id)initWithCoder:(NSCoder *)coder {
	self = [[AMRollOverButtonAppearance alloc] init];
	self.controlColor = [coder decodeObjectForKey:@"am_controlColor"];
	self.frameColor = [coder decodeObjectForKey:@"am_frameColor"];
	self.textColor = [coder decodeObjectForKey:@"am_textColor"];
	self.arrowColor = [coder decodeObjectForKey:@"am_arrowColor"];
	self.shadingColor = [coder decodeObjectForKey:@"am_shadingColor"];
	self.mouseoverControlColor = [coder decodeObjectForKey:@"am_mouseoverControlColor"];
	self.mouseoverFrameColor = [coder decodeObjectForKey:@"am_mouseoverFrameColor"];
	self.mouseoverTextColor = [coder decodeObjectForKey:@"am_mouseoverTextColor"];
	self.mouseoverArrowColor = [coder decodeObjectForKey:@"am_mouseoverArrowColor"];
	self.mouseoverShadingColor = [coder decodeObjectForKey:@"am_mouseoverShadingColor"];
	self.highlightedControlColor = [coder decodeObjectForKey:@"am_highlightedControlColor"];
	self.highlightedFrameColor = [coder decodeObjectForKey:@"am_highlightedFrameColor"];
	self.highlightedTextColor = [coder decodeObjectForKey:@"am_highlightedTextColor"];
	self.highlightedArrowColor = [coder decodeObjectForKey:@"am_highlightedArrowColor"];
	self.highlightedShadingColor = [coder decodeObjectForKey:@"am_highlightedShadingColor"];
	self.controlShadow = [coder decodeObjectForKey:@"am_controlShadow"];
	self.textShadow = [coder decodeObjectForKey:@"am_textShadow"];
	self.mouseoverTextShadow = [coder decodeObjectForKey:@"am_mouseoverTextShadow"];
	self.highlightedTextShadow = [coder decodeObjectForKey:@"am_highlightedTextShadow"];
	self.highlightedControlShadow = [coder decodeObjectForKey:@"am_highlightedControlShadow"];
	self.bezelStyle = [coder decodeIntegerForKey:@"am_bezelStyle"];
	self.shadingMode = [coder decodeIntegerForKey:@"am_shadingMode"];
	self.bordered = [coder decodeBoolForKey:@"am_bordered"];
	self.popUpMenuDelay = [coder decodeDoubleForKey:@"am_popUpMenuDelay"];
	self.alwaysShowMenuIndicator = [coder decodeBoolForKey:@"am_alwaysShowMenuIndicator"];
	return self;
}

@end
